SystemOrganization addCategory: #'JQueryMobile-Core-Callbacks'!

!WASession methodsFor: '*jquerymobile-core-callbacks' stamp: 'NickAger 10/24/2011 07:45'!
advanceKey
	| key |
	key := self nextKey.
	self increaseKey.
	^ key! !

!WASession methodsFor: '*jquerymobile-core-callbacks' stamp: 'NickAger 10/25/2011 14:02'!
componentKey
	^ self properties at: #componentId ifAbsentPut: 1! !

!WASession methodsFor: '*jquerymobile-core-callbacks' stamp: 'NickAger 10/25/2011 14:03'!
increaseKey
	| componentId |
	componentId := self componentKey.
	componentId := componentId + 1.
	self properties at: #componentId put: componentId.! !

!WASession methodsFor: '*jquerymobile-core-callbacks' stamp: 'NickAger 10/25/2011 14:03'!
nextKey
	^ self componentKey greaseString! !

!GRPackage class methodsFor: '*jquerymobile-core-callbacks' stamp: 'NickAger 10/25/2011 11:16'!
jQueryMobileCoreCallbacks
	^ self new
		name: 'JQueryMobile-Core-Callbacks';
		description: 'jQueryMobile callback registry';
		addDependency:  'Seaside-Core';
		addDependency: 'Seaside-Session';
		url: #seasideUrl;
		yourself! !

WACallbackRegistry subclass: #JQMCallbackRegistry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Core-Callbacks'!

!JQMCallbackRegistry methodsFor: 'accessing' stamp: 'NickAger 10/24/2011 12:12'!
advanceKey
	"ensure keys are session unique"
	^ self session advanceKey! !

!JQMCallbackRegistry methodsFor: 'accessing' stamp: 'NickAger 10/24/2011 12:12'!
increaseKey
	"ensure keys are session unique"
	self session increaseKey! !

!JQMCallbackRegistry methodsFor: 'accessing' stamp: 'NickAger 10/24/2011 12:12'!
nextKey
	"ensure keys are session unique"
	^ self session nextKey! !
